var et = Object.defineProperty;
var it = (o, i, t) => i in o ? et(o, i, { enumerable: !0, configurable: !0, writable: !0, value: t }) : o[i] = t;
var c = (o, i, t) => (it(o, typeof i != "symbol" ? i + "" : i, t), t);
import { PlotController as rt, CursorType as M, newScreenPoint as st, OxyModifierKeys as P, OxyMouseButton as v, LineJoin as _, OxyColorHelper as w, FontWeights as R, newOxySize as nt, ClippingRenderContext as K, round as I, isNullOrUndef as z, HorizontalAlignment as E, VerticalAlignment as b, StringHelper as q, OxyImageEx as ot, newOxyRect as N, OxyRectHelper as Z, OxyRect_Empty as G, OxyColors as O, EdgeRenderingMode as A, OxyColorEx as k, arrayBufferToBase64 as lt, newScreenVectorEx as ht, screenPointPlus as B, screenPointMinusVector as at, OxySize_Empty as ct } from "oxyplot-js";
import { create as ut } from "xmlbuilder2";
class J {
  constructor() {
    c(this, "controller");
    c(this, "defaultController");
    c(this, "_zoomRectangle");
    c(this, "_model");
    c(this, "_isModelInvalidated", !1);
    c(this, "_updateDataFlag", !1);
    c(this, "_rendering", !1);
  }
  get actualController() {
    return this.controller ? this.controller : this.defaultController ? this.defaultController : (this.defaultController = new rt(), this.defaultController);
  }
  get actualModel() {
    return this._model;
  }
  get model() {
    return this._model;
  }
  set model(i) {
    const t = this._model;
    this._model = i, this.onModelChanged(t, i);
  }
  onModelChanged(i, t) {
    i && i.attachPlotView(void 0), t && t.attachPlotView(this), this.invalidatePlot(!0);
  }
  invalidatePlot(i) {
    this._isModelInvalidated = !0, this._updateDataFlag = i || !1, this.render();
  }
  render() {
    const i = this._model;
    i && (this._isModelInvalidated && (i.update(this._updateDataFlag), this._isModelInvalidated = !1, this._updateDataFlag = !1), window.requestAnimationFrame(async () => this.renderSync()));
  }
  setClipboardText(i) {
    try {
      navigator.clipboard.writeText(i);
    } catch (t) {
      console.error(t);
    }
  }
  setCursorType(i) {
  }
  hideTracker() {
  }
  showTracker(i) {
  }
  hideZoomRectangle() {
    this._zoomRectangle = void 0;
  }
  showZoomRectangle(i) {
    this._zoomRectangle = i;
  }
  async renderSync() {
    if (this._model && !this._rendering) {
      this._rendering = !0;
      try {
        await this.renderOverride(this._model);
      } finally {
        this._rendering = !1;
      }
    }
  }
}
function C(o) {
  return {
    position: st(o.offsetX, o.offsetY),
    modifierKeys: gt(o),
    handled: !1
  };
}
function dt(o) {
  const i = C(o);
  return i.clickCount = o.detail, i.changedButton = ft(o), i;
}
function wt(o) {
  const i = C(o);
  return i.delta = o.deltaY != 0 ? -o.deltaY : o.deltaX, i;
}
function gt(o) {
  let i = P.None;
  return o.ctrlKey && (i |= P.Control), o.shiftKey && (i |= P.Shift), o.altKey && (i |= P.Alt), o.metaKey && (i |= P.Windows), i;
}
function ft(o) {
  return o.button === 0 ? v.Left : o.button === 1 ? v.Middle : o.button === 2 ? v.Right : o.button === 3 ? v.XButton1 : o.button === 4 ? v.XButton2 : v.None;
}
function j(o) {
  switch (o) {
    case M.Default:
      return "default";
    case M.Pan:
      return "grab";
    case M.ZoomRectangle:
      return "nwse-resize";
    case M.ZoomHorizontal:
      return "ew-resize";
    case M.ZoomVertical:
      return "ns-resize";
    default:
      return "default";
  }
}
function Y(o, i) {
  o.addEventListener("contextmenu", function(t) {
    t.preventDefault();
  }), new ResizeObserver(() => {
    i.invalidatePlot(!1);
  }).observe(o), o.onmousedown = (t) => {
    i.actualController.handleMouseDown(i, dt(t));
  }, o.onmousemove = (t) => {
    i.actualController.handleMouseMove(i, C(t));
  }, o.onmouseup = (t) => {
    i.actualController.handleMouseUp(i, C(t));
  }, o.onmouseenter = (t) => {
    i.actualController.handleMouseEnter(i, C(t));
  }, o.onmouseleave = (t) => {
    i.actualController.handleMouseLeave(i, C(t));
  }, o.onwheel = (t) => {
    i.actualController.handleMouseWheel(i, wt(t));
  };
}
let $ = null;
function mt() {
  if ($)
    return $;
  const o = document.createElement("canvas");
  if ($ = o == null ? void 0 : o.getContext("2d"), !$)
    throw new Error("Could not get canvas context");
  return $;
}
let L = null;
const yt = (o, i, t) => (L || (L = new W()), L.convertFont(o, i, t || R.Normal));
function Q(o) {
  o = o || mt();
  function i(t, e, r, s) {
    if (!o)
      throw new Error("Could not get canvas context");
    o.font = yt(e, r, s);
    const n = o.measureText(t);
    return nt(n.width, r);
  }
  return {
    measureText: i
  };
}
class W {
  convertLineJoin(i) {
    switch (i = i || _.Miter, i) {
      case _.Miter:
        return "miter";
      case _.Bevel:
        return "bevel";
      case _.Round:
        return "round";
    }
  }
  convertStrokeOrFillStyle(i) {
    return w.toRgba(i);
  }
  convertFont(i, t, e) {
    let r = "";
    return (e || R.Normal) > R.Normal && (r += "bold "), r += `${t || 12}px `, i && (r += `"${i}" `), r.trim();
  }
}
class pt {
  constructor() {
    c(this, "cache", /* @__PURE__ */ new Map());
  }
  get(i) {
    return this.cache.get(i);
  }
  set(i, t) {
    this.cache.set(i, t);
  }
  clear(i) {
    i ? this.cache.delete(i) : this.cache.clear();
  }
}
let H = new pt();
function bt() {
  return H;
}
function At(o) {
  H = o;
}
class xt extends K {
  constructor(t) {
    super();
    c(this, "ctx");
    c(this, "_textMeasurer");
    c(this, "styleConverter", new W());
    c(this, "_ctxInitStyles");
    c(this, "_renderContextImageCacheService");
    this.canvas = t;
    const e = t.getContext("2d");
    if (!e)
      throw new Error("Could not get canvas context");
    this.ctx = e, this._ctxInitStyles = {
      fillStyle: e.fillStyle,
      strokeStyle: e.strokeStyle,
      lineJoin: e.lineJoin,
      lineWidth: e.lineWidth
    }, this._renderContextImageCacheService = bt(), this._textMeasurer = Q(e);
  }
  async drawImage(t, e, r, s, n, l, h, a, u, g, d) {
    if (g <= 0)
      return;
    this.resetStyles();
    const x = this.ctx, m = await this.getOrCreateImage(t, () => {
      const f = new Blob([Uint8Array.from(t.data)], { type: "image/png" });
      return createImageBitmap(f);
    });
    x.imageSmoothingEnabled = d, x.drawImage(
      m,
      e,
      r,
      s,
      n,
      I(l, 0),
      I(h, 0),
      I(a, 0),
      I(u, 0)
    );
  }
  /**
   * Draws line segments.
   * @param points The points.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   * @param dashArray The dash array.
   * @param lineJoin The line join.
   */
  async drawLineSegments(t, e, r, s, n, l) {
    if (t.length < 2 || w.isInvisible(e) || r == 0)
      return;
    this.resetStyles();
    const h = this.ctx;
    h.beginPath(), this.applyLineStyle(e, r, s, n, l);
    for (let a = 0; a < t.length; a += 2) {
      const u = t[a], g = t[a + 1];
      this.drawPoints([u, g]);
    }
    h.stroke();
  }
  async drawLine(t, e, r, s, n, l) {
    if (t.length < 2 || w.isInvisible(e) || r == 0)
      return;
    this.resetStyles();
    const h = this.ctx;
    h.beginPath(), this.applyLineStyle(e, r, s, n, l), this.drawPoints(t), h.stroke();
  }
  /**
   * Draws a polygon.
   * @param points The points.
   * @param fill The fill color.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   * @param dashArray The dash array.
   * @param lineJoin The line join.
   */
  async drawPolygon(t, e, r, s, n, l, h) {
    if (w.isInvisible(e) && !(w.isVisible(r) || s <= 0) || t.length < 2)
      return;
    this.resetStyles();
    const a = this.ctx;
    a.beginPath(), this.applyPolygonStyle(e, r, s, n, l, h), this.drawPoints(t), a.closePath(), w.isVisible(e) && a.fill(), w.isVisible(r) && s > 0 && a.stroke();
  }
  /**
   * Draws multiple polygons.
   * @param polygons The polygons.
   * @param fill The fill color.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   * @param dashArray The dash array.
   * @param lineJoin The line join.
   */
  async drawPolygons(t, e, r, s, n, l, h) {
    if (w.isInvisible(e) && !(w.isVisible(r) || s <= 0) || t.length === 0)
      return;
    this.resetStyles();
    const a = this.ctx;
    this.applyPolygonStyle(e, r, s, n, l, h);
    for (const u of t)
      u.length < 2 || (a.beginPath(), this.drawPoints(u), a.closePath(), w.isVisible(e) && a.fill(), w.isVisible(r) && s > 0 && a.stroke());
  }
  /**
   * Draws the text.
   * @param p The position of the text.
   * @param text The text.
   * @param fill The fill color.
   * @param fontFamily The font family.
   * @param fontSize Size of the font.
   * @param fontWeight The font weight.
   * @param rotation The rotation angle.
   * @param horizontalAlignment The horizontal alignment.
   * @param verticalAlignment The vertical alignment.
   * @param maxSize The maximum size of the text.
   */
  async drawText(t, e, r, s, n, l, h, a, u, g) {
    if (!e || w.isInvisible(r))
      return;
    z(a) && (a = E.Left), z(u) && (u = b.Top), this.resetStyles();
    const d = this.ctx;
    n = n || 12, l = l || R.Normal, this.applyTextStyle(r, s, n, l), d.save(), d.translate(t.x, t.y), h && d.rotate(h * (Math.PI / 180));
    const x = q.splitLines(e), m = [];
    for (const p of x) {
      const T = this.measureText(p, s, n, l);
      m.push(T);
    }
    const f = m.reduce((p, T) => p + T.height, 0);
    let y = 0;
    d.textBaseline = "middle", u === b.Top ? y = 0 : u === b.Middle ? y = -f / 2 : u === b.Bottom && (y = -f);
    for (let p = 0; p < x.length; p++) {
      const T = x[p];
      let F = 0;
      const D = m[p];
      a === E.Center ? F = -D.width / 2 : a === E.Right && (F = -D.width), d.fillText(T, F, y + D.height / 2, g == null ? void 0 : g.width), y += D.height;
    }
    d.restore();
  }
  measureText(t, e, r, s) {
    return this._textMeasurer.measureText(t, e, r, s);
  }
  setClip(t) {
    this.ctx.save();
    const e = new Path2D();
    e.rect(t.left, t.top, t.width, t.height), this.ctx.clip(e);
  }
  resetClip() {
    this.ctx.restore();
  }
  resetStyles() {
    const t = this.ctx;
    t.setLineDash([]), Object.assign(t, this._ctxInitStyles);
  }
  applyLineStyle(t, e, r, s, n) {
    const l = this.ctx;
    s && s.length > 0 && l.setLineDash(s), l.lineWidth = e, l.lineJoin = this.styleConverter.convertLineJoin(n), l.strokeStyle = this.styleConverter.convertStrokeOrFillStyle(t);
  }
  applyPolygonStyle(t, e, r, s, n, l) {
    w.isVisible(e) && r > 0 && this.applyLineStyle(e, r, s, n, l), w.isVisible(t) && (this.ctx.fillStyle = this.styleConverter.convertStrokeOrFillStyle(t));
  }
  applyTextStyle(t, e, r, s) {
    const n = this.ctx;
    n.fillStyle = this.styleConverter.convertStrokeOrFillStyle(t), n.font = this.styleConverter.convertFont(e, r, s);
  }
  drawPoints(t) {
    this.ctx.moveTo(t[0].x, t[0].y);
    for (let e = 1; e < t.length; e++) {
      const r = t[e];
      this.ctx.lineTo(r.x, r.y);
    }
  }
  async getOrCreateImage(t, e) {
    const r = ot.from(t).getHashCode().toString(), s = this._renderContextImageCacheService.get(r);
    if (s)
      return Promise.resolve(s);
    const n = await e();
    return this._renderContextImageCacheService.set(r, n), n;
  }
}
class Tt extends J {
  constructor(t) {
    super();
    c(this, "_view");
    c(this, "_tooltip");
    c(this, "_renderContext");
    c(this, "_drawCtx");
    c(this, "_styleConverter", new W());
    if (this._view = t, this.setupCanvas(t), this._drawCtx = this._view.getContext("2d"), !this._drawCtx)
      throw new Error("Could not get 2d context");
    this._tooltip = document.createElement("div"), this._tooltip.style.position = "absolute", this._tooltip.style.zIndex = "100", this._tooltip.style.backgroundColor = "#FFFFA0E0", this._tooltip.style.border = "1px solid black", this._tooltip.style.padding = "8px", this._tooltip.style.visibility = "hidden", this._tooltip.style.pointerEvents = "none", this._tooltip.style.transition = "transform 0.2s ease, top 0.2s ease, left 0.2s ease", document.body.appendChild(this._tooltip), this._renderContext = new xt(this._view), Y(this._view, this), new ResizeObserver(() => {
      this.setupCanvas(t);
    }).observe(t);
  }
  setupCanvas(t) {
    const e = window.devicePixelRatio || 1, r = t.getBoundingClientRect();
    r.width === 0 || r.height === 0 || (t.width = r.width * e, t.height = r.height * e);
  }
  get tooltip() {
    return this._tooltip;
  }
  get clientArea() {
    return N(0, 0, this._view.width, this._view.height);
  }
  hideTracker() {
    this._tooltip.style.visibility = "hidden", this._tooltip.style.top = "unset", this._tooltip.style.left = "unset";
  }
  showTracker(t) {
    if (!(t != null && t.position))
      return;
    const e = t.toString() || "";
    if (e.trim().length === 0)
      return;
    const { top: r, left: s } = this._view.getBoundingClientRect();
    this._tooltip.innerText = e, this._tooltip.style.top = `${r + t.position.y}px`, this._tooltip.style.left = `${s + t.position.x}px`, this._tooltip.style.visibility = "visible";
  }
  setCursorType(t) {
    this._view.style.cursor = j(t);
  }
  async renderOverride(t) {
    this._drawCtx = this._view.getContext("2d");
    const e = window.devicePixelRatio || 1;
    this._drawCtx.scale(e, e);
    const r = this._view;
    if (this._drawCtx.reset(), w.isUndefined(t.background) || (this._drawCtx.fillStyle = this._styleConverter.convertStrokeOrFillStyle(t.background), this._drawCtx.fillRect(0, 0, r.width, r.height)), await t.render(this._renderContext, N(0, 0, r.width, r.height)), this._zoomRectangle && Z.equals(this._zoomRectangle, G)) {
      const s = w.parse("#40FFFF00"), n = O.Black;
      await this._renderContext.drawRectangle(this._zoomRectangle, s, n, 1, A.Automatic);
    }
  }
}
const X = "1.0", U = "utf-8", S = (o) => {
};
class St {
  /**
   * Initializes a new instance of the XmlWriterBase class.
   * @param stream The stream.
   */
  constructor(i) {
    c(this, "_no", 0);
    /**
     * The xml writer.
     */
    c(this, "w");
    c(this, "_stream");
    c(this, "_xml", "");
    /// <summary>
    /// The disposed flag.
    /// </summary>
    c(this, "_disposed", !1);
    this._stream = i, this.w = ut({
      version: X,
      encoding: U
    });
  }
  /**
   * Closes this instance.
   */
  close() {
  }
  /**
   * Flushes this instance.
   */
  flush() {
  }
  getXml() {
    return this._xml;
  }
  /**
   * Writes an attribute string.
   * @param name The name.
   * @param value The value.
   */
  writeAttributeString(i, t) {
    this._no++, S(`${this._no},writeAttributeString,${i},${t}`), this.w.att(i, t);
  }
  /**
   * Writes an attribute string with a prefix.
   * @param prefix The prefix.
   * @param name The name.
   * @param ns The constant.
   * @param value The value.
   */
  writeAttributeString2(i, t, e, r) {
    this._no++, S(`${this._no},writeAttributeString,${i},${t},${e},${r}`), t = i ? `${i}:${t}` : t, e ? this.w.att(e, t, r) : this.writeAttributeString(t, r);
  }
  /**
   * Writes the doc type.
   * @param name The name of the DOCTYPE. This must be non-empty.
   * @param pubid If non-null it also writes PUBLIC "pubid" "sysid" where pubid and sysid are replaced with the value of the given arguments.
   * @param sysid If pubid is null and sysid is non-null it writes SYSTEM "sysid" where sysid is replaced with the value of this argument.
   * @param subset If non-null it writes [subset] where subset is replaced with the value of this argument.
   */
  writeDocType(i, t, e, r) {
    this._no++, S(`${this._no},writeDocType,${i},${t},${e}`), this.w.dtd({
      name: i,
      pubID: t,
      sysID: e
    });
  }
  /**
   * Writes an element string.
   * @param name The name.
   * @param text The text.
   */
  writeElementString(i, t) {
    this._no++, S(`${this._no},writeElementString,${i},${t}`), this.writeStartElement(i), this.writeString(t);
  }
  /**
   * Writes the end document.
   */
  writeEndDocument() {
    this._no++, S(`${this._no},writeEndDocument`), this._xml = this.w.end({
      prettyPrint: !0
    }), this._no = 0;
  }
  /**
   * Writes an element end tag.
   */
  writeEndElement() {
    this._no++, S(`${this._no},writeEndElement`), this.w = this.w.up();
  }
  /**
   * Writes raw text.
   * @param text The text.
   */
  writeRaw(i) {
    this._no++, S(`${this._no},writeRaw,${i}`), this.w.dat(i);
  }
  /**
   * Writes the start document.
   * @param standalone The standalone.
   */
  writeStartDocument(i) {
    this._no++, S(`${this._no},writeStartDocument,${i}`), this.w.dec({
      version: X,
      encoding: U,
      standalone: i
    });
  }
  /**
   * Writes an element start tag.
   * @param name The name.
   * @param ns The ns.
   */
  writeStartElement(i, t) {
    this._no++, S(`${this._no},writeStartElement,${i},${t || ""}`), t ? this.w = this.w.ele(t, i) : this.w = this.w.ele(i);
  }
  /**
   * Writes a string.
   * @param text The text.
   */
  writeString(i) {
    this._no++, S(`${this._no},writeString,${i}`), this.w.txt(i);
  }
  dispose() {
    this._disposed || (this._disposed = !0, this.close());
  }
}
class _t extends St {
  /**
   * Initializes a new instance of the SvgWriter class.
   * @param width The width (in user units).
   * @param height The height (in user units).
   * @param isDocument if set to true, the writer will write the xml headers (?xml and !DOCTYPE).
   */
  constructor(t, e, r = !0) {
    super();
    c(this, "endIsWritten", !1);
    c(this, "clipPathNumber", 1);
    c(this, "isDocument");
    c(this, "numberFormat");
    this.isDocument = r, this.numberFormat = (s) => I(s, 4).toString(), this.writeHeader(t, e);
  }
  /**
   * Closes the svg document.
   */
  close() {
    this.endIsWritten || this.complete();
  }
  /**
   * Writes the end of the document.
   */
  complete() {
    this.writeEndElement(), this.isDocument && this.writeEndDocument(), this.endIsWritten = !0;
  }
  /**
   * Creates a style.
   * @param fill The fill color.
   * @param stroke The stroke color.
   * @param thickness The stroke thickness (in user units).
   * @param dashArray The line dash array.
   * @param lineJoin The line join type.
   * @returns A style string.
   */
  createStyle(t, e, r, s = [], n = _.Miter) {
    const l = k.fromOxyColor(t);
    let h = "";
    w.isInvisible(l) ? h += "fill:none;" : (h += `fill:${this.colorToString(l)};`, l.a !== 255 && (h += `fill-opacity:${l.a / 255};`));
    const a = k.fromOxyColor(e);
    if (w.isInvisible(e))
      h += "stroke:none;";
    else {
      const u = this.numberFormat(r);
      switch (h += `stroke:${this.colorToString(a)};stroke-width:${u}`, n) {
        case _.Round:
          h += ";stroke-linejoin:round";
          break;
        case _.Bevel:
          h += ";stroke-linejoin:bevel";
          break;
      }
      if (a.a !== 255 && (h += `;stroke-opacity:${a.a / 255}`), s && s.length > 0) {
        h += ";stroke-dasharray:";
        for (let g = 0; g < s.length; g++)
          h += `${g > 0 ? "," : ""}${s[g]}`;
      }
    }
    return h;
  }
  /**
   * Writes an ellipse.
   * @param x The x-coordinate of the center.
   * @param y The y-coordinate of the center.
   * @param width The width.
   * @param height The height.
   * @param style The style.
   * @param edgeRenderingMode The edge rendering mode.
   */
  writeEllipse(t, e, r, s, n, l) {
    this.writeStartElement("ellipse"), this.writeAttributeNumberString("cx", t + r / 2), this.writeAttributeNumberString("cy", e + s / 2), this.writeAttributeNumberString("rx", r / 2), this.writeAttributeNumberString("ry", s / 2), this.writeAttributeString("style", n), this.writeEdgeRenderingModeAttribute(l), this.writeEndElement();
  }
  /**
   * Sets a clipping rectangle.
   * @param x The x coordinate of the clipping rectangle.
   * @param y The y coordinate of the clipping rectangle.
   * @param width The width of the clipping rectangle.
   * @param height The height of the clipping rectangle.
   */
  beginClip(t, e, r, s) {
    const n = "clipPath" + this.clipPathNumber++;
    this.writeStartElement("defs"), this.writeStartElement("clipPath"), this.writeAttributeString("id", n), this.writeStartElement("rect"), this.writeAttributeNumberString("x", t), this.writeAttributeNumberString("y", e), this.writeAttributeNumberString("width", r), this.writeAttributeNumberString("height", s), this.writeEndElement(), this.writeEndElement(), this.writeEndElement(), this.writeStartElement("g"), this.writeAttributeString("clip-path", `url(#${n})`);
  }
  /**
   * Resets the clipping rectangle.
   */
  endClip() {
    this.writeEndElement();
  }
  /**
   * Writes a portion of the specified image.
   * @param srcX The x-coordinate of the upper-left corner of the portion of the source image to draw.
   * @param srcY The y-coordinate of the upper-left corner of the portion of the source image to draw.
   * @param srcWidth Width of the portion of the source image to draw.
   * @param srcHeight Height of the portion of the source image to draw.
   * @param destX The destination x-coordinate.
   * @param destY The destination y-coordinate.
   * @param destWidth Width of the destination rectangle.
   * @param destHeight Height of the destination rectangle.
   * @param image The image.
   * @param interpolate Interpolate if set to true.
   */
  writeImage(t, e, r, s, n, l, h, a, u, g) {
    const d = n - t / r * h, x = u.width / r * h, m = l - e / s * a, f = u.height / s * a;
    this.beginClip(n, l, h, a), this.writeImage2(d, m, x, f, u, g), this.endClip();
  }
  /**
   * Writes the specified image.
   * @param x The x-coordinate.
   * @param y The y-coordinate.
   * @param width The width of the image.
   * @param height The height of the image.
   * @param image The image.
   * @param interpolate Interpolate if set to true.
   */
  writeImage2(t, e, r, s, n, l) {
    this.writeStartElement("image"), this.writeAttributeNumberString("x", t), this.writeAttributeNumberString("y", e), this.writeAttributeNumberString("width", r), this.writeAttributeNumberString("height", s), this.writeAttributeString("preserveAspectRatio", "none"), l || this.writeAttributeString("image-rendering", "pixelated");
    const a = "data:image/png;base64," + lt(Uint8Array.from(n.data));
    this.writeAttributeString("xlink:href", a), this.writeEndElement();
  }
  /**
   * Writes a line.
   * @param p1 The first point.
   * @param p2 The second point.
   * @param style The style.
   * @param edgeRenderingMode The edge rendering mode.
   */
  writeLine(t, e, r, s) {
    this.writeStartElement("line"), this.writeAttributeNumberString("x1", t.x), this.writeAttributeNumberString("y1", t.y), this.writeAttributeNumberString("x2", e.x), this.writeAttributeNumberString("y2", e.y), this.writeAttributeString("style", r), this.writeEdgeRenderingModeAttribute(s), this.writeEndElement();
  }
  /**
   * Writes a polygon.
   * @param points The points.
   * @param style The style.
   * @param edgeRenderingMode The edge rendering mode.
   */
  writePolygon(t, e, r) {
    this.writeStartElement("polygon"), this.writeAttributeString("points", this.pointsToString(t)), this.writeAttributeString("style", e), this.writeEdgeRenderingModeAttribute(r), this.writeEndElement();
  }
  /**
   * Writes a polyline.
   * @param pts The points.
   * @param style The style.
   * @param edgeRenderingMode The edge rendering mode.
   */
  writePolyline(t, e, r) {
    this.writeStartElement("polyline"), this.writeAttributeString("points", this.pointsToString(t)), this.writeAttributeString("style", e), this.writeEdgeRenderingModeAttribute(r), this.writeEndElement();
  }
  /**
   * Writes a rectangle.
   * @param x The x coordinate.
   * @param y The y coordinate.
   * @param width The width.
   * @param height The height.
   * @param style The style.
   * @param edgeRenderingMode The edge rendering mode.
   */
  writeRectangle(t, e, r, s, n, l) {
    this.writeStartElement("rect"), this.writeAttributeNumberString("x", t), this.writeAttributeNumberString("y", e), this.writeAttributeNumberString("width", r), this.writeAttributeNumberString("height", s), this.writeAttributeString("style", n), this.writeEdgeRenderingModeAttribute(l), this.writeEndElement();
  }
  /**
   * Writes text.
   * @param position The position.
   * @param text The text.
   * @param fill The text color.
   * @param fontFamily The font family.
   * @param fontSize The font size (in user units).
   * @param fontWeight The font weight.
   * @param rotate The rotation angle.
   * @param halign The horizontal alignment.
   * @param valign The vertical alignment.
   */
  writeText(t, e, r, s = null, n = 10, l = R.Normal, h = 0, a = E.Left, u = b.Top) {
    this.writeStartElement("text");
    let g = "hanging";
    u === b.Middle && (g = "middle"), u === b.Bottom && (g = "baseline"), this.writeAttributeString("dominant-baseline", g);
    let d = "start";
    a === E.Center && (d = "middle"), a === E.Right && (d = "end"), this.writeAttributeString("text-anchor", d);
    let m = `translate(${t.x},${t.y})`;
    Math.abs(h) > 0 && (m += ` rotate(${h})`), this.writeAttributeString("transform", m), s && this.writeAttributeString("font-family", s), n > 0 && this.writeAttributeNumberString("font-size", n), l > 0 && this.writeAttributeNumberString("font-weight", l);
    const f = k.fromOxyColor(r);
    w.isInvisible(r) ? this.writeAttributeString("fill", "none") : (this.writeAttributeString("fill", this.colorToString(f)), f.a !== 255 && this.writeAttributeNumberString("fill-opacity", f.a / 255)), e.length !== e.trim().length && this.writeAttributeString2("xml", "space", "", "preserve"), this.writeString(e), this.writeEndElement();
  }
  /**
   * Converts a color to a svg color string.
   * @param color The color.
   * @returns The color string.
   */
  colorToString(t) {
    return w.equals(t, O.Black) ? "black" : `rgb(${t.r},${t.g},${t.b})`;
  }
  /**
   * Writes a double attribute.
   * @param name The name.
   * @param value The value.
   */
  writeAttributeNumberString(t, e) {
    this.writeAttributeString(t, this.numberFormat(e));
  }
  /**
   * Writes the edge rendering mode attribute if necessary.
   * @param edgeRenderingMode The edge rendering mode.
   */
  writeEdgeRenderingModeAttribute(t) {
    let e;
    switch (t) {
      case A.PreferSharpness:
        e = "crispEdges";
        break;
      case A.PreferSpeed:
        e = "optimizeSpeed";
        break;
      case A.PreferGeometricAccuracy:
        e = "geometricPrecision";
        break;
      default:
        return;
    }
    this.writeAttributeString("shape-rendering", e);
  }
  /**
   * Converts a value to a string or to the specified "auto" string if the value is NaN.
   * @param value The value.
   * @param auto The string to return if value is NaN.
   * @returns A string.
   */
  getAutoValue(t, e) {
    return isNaN(t) ? e : this.numberFormat(t);
  }
  /**
   * Converts a list of points to a string.
   * @param points The points.
   * @returns A string.
   */
  pointsToString(t) {
    let e = "";
    for (const r of t)
      e += `${this.numberFormat(r.x)},${this.numberFormat(r.y)} `;
    return e.trim();
  }
  /**
   * Writes the header.
   * @param width The width.
   * @param height The height.
   */
  writeHeader(t, e) {
    this.isDocument && (this.writeStartDocument(!1), this.writeDocType("svg", "-//W3C//DTD SVG 1.1//EN", "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd")), this.writeStartElement("svg", "http://www.w3.org/2000/svg"), this.writeAttributeString("width", this.getAutoValue(t, "100%")), this.writeAttributeString("height", this.getAutoValue(e, "100%")), this.writeAttributeString("version", "1.1"), this.writeAttributeString("xmlns:xlink", "http://www.w3.org/1999/xlink");
  }
}
class tt extends K {
  /**
   * Initializes a new instance of the SvgRenderContext class.
   * @param width The width.
   * @param height The height.
   * @param isDocument Create an SVG document if set to true.
   * @param textMeasurer The text measurer.
   * @param background The background.
   * @param useVerticalTextAlignmentWorkaround Whether to use the workaround for vertical text alignment.
   */
  constructor(t, e, r, s, n, l = !1) {
    super();
    /**
     * The writer.
     */
    c(this, "w");
    /**
     * Gets or sets the text measurer.
     */
    c(this, "textMeasurer");
    /**
     * Gets or sets a value indicating whether to use a workaround for vertical text alignment to support renderers with limited support for the dominate-baseline attribute.
     */
    c(this, "useVerticalTextAlignmentWorkaround");
    c(this, "disposed", !1);
    if (!s)
      throw new Error("A text measuring render context must be provided.");
    this.w = new _t(t, e, r), this.textMeasurer = s, this.useVerticalTextAlignmentWorkaround = l, w.isVisible(n) && this.w.writeRectangle(
      0,
      0,
      t,
      e,
      this.w.createStyle(n, O.Undefined, 0),
      A.Adaptive
    );
  }
  /**
   * Closes the svg writer.
   */
  close() {
    this.w.close();
  }
  /**
   * Completes the svg element.
   */
  complete() {
    this.w.complete();
  }
  getXml() {
    return this.w.getXml();
  }
  /**
   * Draws an ellipse.
   * @param rect The rectangle.
   * @param fill The fill color.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   */
  async drawEllipse(t, e, r, s, n) {
    this.w.writeEllipse(
      t.left,
      t.top,
      t.width,
      t.height,
      this.w.createStyle(e, r, s),
      n
    );
  }
  /**
   * Draws a line.
   * @param points The points.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   * @param dashArray The dash array.
   * @param lineJoin The line join.
   */
  async drawLine(t, e, r, s, n, l) {
    this.w.writePolyline(
      t,
      this.w.createStyle(O.Undefined, e, r, n, l),
      s
    );
  }
  /**
   * Draws a polygon.
   * @param points The points.
   * @param fill The fill color.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   * @param dashArray The dash array.
   * @param lineJoin The line join.
   */
  async drawPolygon(t, e, r, s, n, l, h) {
    this.w.writePolygon(t, this.w.createStyle(e, r, s, l, h), n);
  }
  /**
   * Draws a rectangle.
   * @param rect The rectangle.
   * @param fill The fill color.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   */
  async drawRectangle(t, e, r, s, n) {
    this.w.writeRectangle(
      t.left,
      t.top,
      t.width,
      t.height,
      this.w.createStyle(e, r, s),
      n
    );
  }
  /**
   * Draws the text.
   * @param p The position.
   * @param text The text.
   * @param c The color.
   * @param fontFamily The font family.
   * @param fontSize The font size.
   * @param fontWeight The font weight.
   * @param rotate The rotation angle.
   * @param halign The horizontal alignment.
   * @param valign The vertical alignment.
   * @param maxSize The maximum size.
   */
  async drawText(t, e, r, s, n, l, h, a, u, g) {
    if (!e)
      return;
    const d = q.splitLines(e), m = this.measureText(e, s, n, l).height / d.length, f = ht(
      -Math.sin(h / 180 * Math.PI) * m,
      +Math.cos(h / 180 * Math.PI) * m
    );
    if (this.useVerticalTextAlignmentWorkaround) {
      const y = u === b.Bottom ? 1 - d.length : u === b.Top ? 1 : 1 - d.length / 2;
      u = b.Bottom, t = B(t, f.times(y));
      for (const p of d)
        this.w.writeText(t, p, r, s, n, l, h, a, u), t = B(t, f);
    } else if (u === b.Bottom)
      for (let y = d.length - 1; y >= 0; y--) {
        const p = d[y];
        this.w.writeText(t, p, r, s, n, l, h, a, u), t = at(t, f);
      }
    else
      for (const y of d)
        this.w.writeText(t, y, r, s, n, l, h, a, u), t = B(t, f);
  }
  /**
   * Flushes this instance.
   */
  flush() {
    this.w.flush();
  }
  /**
   * Measures the text.
   * @param text The text.
   * @param fontFamily The font family.
   * @param fontSize Size of the font.
   * @param fontWeight The font weight.
   * @returns The text size.
   */
  measureText(t, e, r, s) {
    return t === "" ? ct : this.textMeasurer.measureText(t, e, r, s);
  }
  /**
   * Draws the specified portion of the specified OxyImage at the specified location and with the specified size.
   * @param source The source.
   * @param srcX The x-coordinate of the upper-left corner of the portion of the source image to draw.
   * @param srcY The y-coordinate of the upper-left corner of the portion of the source image to draw.
   * @param srcWidth Width of the portion of the source image to draw.
   * @param srcHeight Height of the portion of the source image to draw.
   * @param destX The x-coordinate of the upper-left corner of drawn image.
   * @param destY The y-coordinate of the upper-left corner of drawn image.
   * @param destWidth The width of the drawn image.
   * @param destHeight The height of the drawn image.
   * @param opacity The opacity.
   * @param interpolate Interpolate if set to true.
   */
  async drawImage(t, e, r, s, n, l, h, a, u, g, d) {
    this.w.writeImage(e, r, s, n, l, h, a, u, t, d);
  }
  /**
   * Releases unmanaged and - optionally - managed resources
   * @param disposing true to release both managed and unmanaged resources; false to release only unmanaged resources.
   */
  dispose(t) {
    this.disposed || t && this.w.dispose(), this.disposed = !0;
  }
  /**
   * Sets the clipping rectangle.
   * @param clippingRectangle The clipping rectangle.
   */
  setClip(t) {
    this.w.beginClip(t.left, t.top, t.width, t.height);
  }
  /**
   * Resets the clipping rectangle.
   */
  resetClip() {
    this.w.endClip();
  }
}
class Mt extends J {
  constructor(t) {
    super();
    c(this, "_view");
    c(this, "_tooltip");
    //private readonly _drawCtx: HTMLElement
    c(this, "textMeasurer");
    this._view = t, this.textMeasurer = Q(), this._tooltip = document.createElement("div"), this._tooltip.style.position = "absolute", this._tooltip.style.zIndex = "100", this._tooltip.style.backgroundColor = "#FFFFA0E0", this._tooltip.style.border = "1px solid black", this._tooltip.style.padding = "8px", this._tooltip.style.visibility = "hidden", this._tooltip.style.pointerEvents = "none", this._tooltip.style.transition = "transform 0.2s ease, top 0.2s ease, left 0.2s ease", document.body.appendChild(this._tooltip), Y(this._view, this);
  }
  get tooltip() {
    return this._tooltip;
  }
  get clientArea() {
    return N(0, 0, this._view.clientWidth, this._view.clientHeight);
  }
  hideTracker() {
    this._tooltip.style.visibility = "hidden", this._tooltip.style.top = "unset", this._tooltip.style.left = "unset";
  }
  showTracker(t) {
    if (!(t != null && t.position))
      return;
    const e = t.toString() || "";
    if (e.trim().length === 0)
      return;
    const r = this._view.offsetTop, s = this._view.offsetLeft;
    this._tooltip.innerText = e, this._tooltip.style.top = `${r + t.position.y}px`, this._tooltip.style.left = `${s + t.position.x}px`, this._tooltip.style.visibility = "visible";
  }
  setCursorType(t) {
    this._view.style.cursor = j(t);
  }
  async renderOverride(t) {
    const e = this._view;
    this._view.innerHTML = "";
    const r = new tt(
      e.clientWidth,
      e.clientHeight,
      !0,
      this.textMeasurer,
      t.background
    );
    if (w.isUndefined(t.background) || (this._view.style.backgroundColor = t.background.toString()), await t.render(r, N(0, 0, e.clientWidth, e.clientHeight)), this._zoomRectangle && Z.equals(this._zoomRectangle, G)) {
      const s = w.parse("#40FFFF00"), n = O.Black;
      await r.drawRectangle(this._zoomRectangle, s, n, 1, A.Automatic);
    }
    r.complete(), this._view.innerHTML = r.getXml();
  }
}
class V {
  /**
   * Initializes a new instance of the SvgExporter class.
   */
  constructor() {
    /**
     * Gets or sets the width (in user units) of the output area.
     */
    c(this, "width");
    /**
     * Gets or sets the height (in user units) of the output area.
     */
    c(this, "height");
    /**
     * Gets or sets a value indicating whether the xml headers should be included.
     */
    c(this, "isDocument");
    /**
     * Gets or sets a value indicating whether to use a workaround for vertical text alignment to support renderers with limited support for the dominate-baseline attribute.
     */
    c(this, "useVerticalTextAlignmentWorkaround", !1);
    /**
     * Gets or sets the text measurer.
     */
    c(this, "textMeasurer");
    this.width = 600, this.height = 400, this.isDocument = !0;
  }
  /**
   * Exports the specified model to a stream.
   * @param model The model.
   * @param width The width (points).
   * @param height The height (points).
   * @param isDocument if set to true, the xml headers will be included (?xml and !DOCTYPE).
   * @param textMeasurer The text measurer.
   * @param useVerticalTextAlignmentWorkaround Whether to use the workaround for vertical text alignment
   */
  static async export(i, t, e, r, s, n = !1) {
    if (!s)
      throw new Error("textMeasurer is required");
    const l = new tt(
      t,
      e,
      r,
      s,
      i.background,
      n
    );
    return i.update(!0), await i.render(l, N(0, 0, t, e)), l.complete(), l.flush(), l.getXml();
  }
  /**
   * Exports to string.
   * @param model The model.
   * @param width The width (points).
   * @param height The height (points).
   * @param isDocument if set to true, the xml headers will be included (?xml and !DOCTYPE).
   * @param textMeasurer The text measurer.
   * @returns The plot as an SVG string.
   * @param useVerticalTextAlignmentWorkaround Whether to use the workaround for vertical text alignment
   */
  static exportToString(i, t, e, r, s, n = !1) {
    return this.export(i, t, e, r, s, n);
  }
  /**
   * Exports the specified PlotModel to a Stream.
   * @param model The model to export.
   */
  async export(i) {
    const t = await V.export(
      i,
      this.width,
      this.height,
      this.isDocument,
      this.textMeasurer,
      this.useVerticalTextAlignmentWorkaround
    );
    return new TextEncoder().encode(t).buffer;
  }
  /**
   * Exports the specified PlotModel to a string.
   * @param model The model.
   * @returns the SVG content as a string.
   */
  exportToString(i) {
    return V.exportToString(
      i,
      this.width,
      this.height,
      this.isDocument,
      this.textMeasurer,
      this.useVerticalTextAlignmentWorkaround
    );
  }
}
export {
  Tt as CanvasPlotView,
  W as OxyStyleToCanvasStyleConverter,
  V as SvgExporter,
  Mt as SvgPlotView,
  tt as SvgRenderContext,
  _t as SvgWriter,
  J as WebPlotViewBase,
  Q as canvasTextMeasurer,
  bt as getRenderContextImageCacheService,
  At as setRenderContextImageCacheService
};
